﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using lib2ch.IO;

namespace lib2ch.Data
{
    public class Replacer
    {
        List<RegexText> _List;
        public Replacer()
        {
            _List = new List<RegexText>();
        }
        public void Load(string FullPath)
        {
            File file = new File();
            FileResult fileResult = file.LocalReader(FullPath);
            //正規表現のファイル有無
            if (fileResult == null) return;
            //置換前と置換後の2行単位なので奇数チェック
            int Count = fileResult.Line.Count;
            if ((Count & 0x01) == 1) Count -= 1;
            //最低でも１つ分置換用コードがあるか
            if (Count < 2) return;
            for (int i = 0; i < Count;)
            {
                RegexText RegexText = new RegexText();
                RegexText.Before = fileResult.Line[i];
                RegexText.After = fileResult.Line[i + 1];
                i += 2;
                _List.Add(RegexText);
            }
            return;
        }
        public string Replace(string Line)
        {
            foreach (RegexText RegexText in _List)
            {
                Line = Regex.Replace(Line,RegexText.Before,RegexText.After);
            }
            return Line;
        }
    }
}
